<script setup lang="ts">
import { useMemberStore } from '@/stores/member';
import type { Member } from '@/types/Member';
import { nextTick, onMounted, ref } from 'vue';
import type { VForm } from 'vuetify/components';

const headers = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Tel',
    key: 'tel',
  },
  {
    title: 'Point',
    key: 'point',
  },
  { title: 'Actions', key: 'actions', sortable: false }
]
const useMember = useMemberStore()
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
function onSubmit() { }

async function editItem(item: Member) {
  if (!item.id) return
  await useMember.getMember(item.id)
  dialog.value = true
}
async function deleteItem(item: Member) {
  if (!item.id) return
  await useMember.getMember(item.id)
  dialogDelete.value = true
}
function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    useMember.clearForm()
  })
}
async function deleteItemConfirm() {
  // Delete item from list
  await useMember.deleteMember()
  closeDelete()
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    useMember.clearForm()
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await useMember.saveMember()
  closeDialog()
}
onMounted(async () => {
  await useMember.getMembers()

})
</script>

<template>
  <div><v-data-table :headers="headers" :items="useMember.members" height="calc(90vh - 200px)" >
      <template v-slot:top>
        <v-toolbar flat color="#8B7565">
          <v-toolbar-title style="color:#ECE2D3 ;" >Members</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <!-- Put Edited Dialog -->

          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn color="#ECE2D3" v-bind="props"> New Member </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Member Profile</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field v-model="useMember.editedMember.name" :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2" clearable label="Name"></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field v-model="useMember.editedMember.tel" :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2" clearable label="Tel"></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field v-model="useMember.editedMember.point" class="mb-2" clearable
                          label="Point"></v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <!-- Delete Dialog-->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>

      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
        <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>


    </v-data-table>
  </div>
</template>
